import { b as r } from "./tslib.es6-CJ7TUrOc.mjs";
import { e as m, x as l, r as x, i as k } from "./query-assigned-elements-D930kELM.mjs";
import { s as g, C as b } from "./mwc-checkbox.css-BrjbMwch.mjs";
import { n as d } from "./property-DJzm_oB9.mjs";
import { i as f } from "./query-CDOd1Kwm.mjs";
import { o as $ } from "./class-map-DPUylGZM.mjs";
import { L as u, s as y } from "./mwc-list-item.css-BtGzAhUF.mjs";
import { s as C, c as v } from "./list-item-CK66f3gK.mjs";
/**
 * @license
 * Copyright 2018 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
let p = class extends b {
};
p.styles = [g];
p = r([
  m("mwc-checkbox")
], p);
/**
 * @license
 * Copyright 2020 Google LLC
 * SPDX-License-Identifier: Apache-2.0
 */
class i extends u {
  constructor() {
    super(...arguments), this.left = !1, this.graphic = "control";
  }
  render() {
    const t = {
      "mdc-deprecated-list-item__graphic": this.left,
      "mdc-deprecated-list-item__meta": !this.left
    }, e = this.renderText(), c = this.graphic && this.graphic !== "control" && !this.left ? this.renderGraphic() : l``, s = this.hasMeta && this.left ? this.renderMeta() : l``, o = this.renderRipple();
    return l`
      ${o}
      ${c}
      ${this.left ? "" : e}
      <span class=${$(t)}>
        <mwc-checkbox
            reducedTouchTarget
            tabindex=${this.tabindex}
            .checked=${this.selected}
            ?disabled=${this.disabled}
            @change=${this.onChange}>
        </mwc-checkbox>
      </span>
      ${this.left ? e : ""}
      ${s}`;
  }
  async onChange(t) {
    const e = t.target;
    this.selected === e.checked || (this._skipPropRequest = !0, this.selected = e.checked, await this.updateComplete, this._skipPropRequest = !1);
  }
}
r([
  f("slot")
], i.prototype, "slotElement", void 0);
r([
  f("mwc-checkbox")
], i.prototype, "checkboxElement", void 0);
r([
  d({ type: Boolean })
], i.prototype, "left", void 0);
r([
  d({ type: String, reflect: !0 })
], i.prototype, "graphic", void 0);
var _ = Object.getOwnPropertyDescriptor, w = (a, t, e, c) => {
  for (var s = c > 1 ? void 0 : c ? _(t, e) : t, o = a.length - 1, n; o >= 0; o--)
    (n = a[o]) && (s = n(s) || s);
  return s;
};
let h = class extends i {
};
h.styles = [
  y,
  C,
  k`
      ${x(v)}
    `
];
h = w([
  m("cv-check-list-item")
], h);
const E = h;
export {
  h as CovalentCheckListItem,
  E as default
};
